/*
	specific implementation for accessing data in the database
*/

import java.util.*;
import java.lang.*;
import java.sql.*;
import java.util.Properties;
import oracle.jdbc.driver.*;

public class jdbcModule implements dataAccess {
  
 	 private Connection conn;
  
/*
	public void open(String protocol, String location, String id, String pwd)

	: connect to the Oracle database
*/

	public void open(String protocol, String location, String id, String pwd) {

		String url = "jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe";

    	try {
	
			DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
      		conn = DriverManager.getConnection(url, id, pwd);
			conn.setAutoCommit(false);

   		} catch (Exception e) { 

			e.printStackTrace();
			System.exit(0);
		}
	}


/*
	public void update()

	: commit all changes and then disconnect from the database
*/

  	public void update() {

    	try {

			if (conn != null) {

				conn.commit();
				conn.setAutoCommit(true);
   		   		conn.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

    	} catch (Exception e) {

			e.printStackTrace();
		}
  	}


/*
	public void close()

	: disconnect from the database without commit
*/

  	public void close() {

    	try {

			if (conn != null) {

				conn.rollback();
				conn.setAutoCommit(true);
				conn.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch (Exception e)  {

			e.printStackTrace();
		}
}


/*
	public String getValue(String name, String key) 

	: return the value of the key, of which the user with the given name
	  has. If the user or the key does not exist, return null
*/

	public String getValue(String name, String key) { 
	
	 	String command = "SELECT value FROM user_data WHERE name = '"
						 + name + "' AND key = '" + key.toLowerCase() + "'";
		String valueOfKey = null;
	  	PreparedStatement pstmt;
	  	ResultSet rs;

		try {

			if (conn != null) {

	  			pstmt = conn.prepareStatement(command);
	  			rs = pstmt.executeQuery();

	  			if (rs.next()) {

			  		valueOfKey = rs.getString(1);
				}

	  			pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch (SQLException e) {

	  		e.printStackTrace();
		}

		return valueOfKey;
	}

/*

	public Enumeration getUsers()

	: Retrieve names of all users

*/

	public Enumeration getUsers() {

		ResultSet rs;
		Vector v = new Vector(20);
		PreparedStatement pstmt;
		String command = "SELECT name FROM users";
		
		try {

			if (conn != null) {

		  		pstmt = conn.prepareStatement(command);
				rs = pstmt.executeQuery();

				while ( rs.next() ) {

					v.addElement(rs.getString(1));
				}

				pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to databse");
			}

		} catch (SQLException e) {

			e.printStackTrace();
		}

		return v.elements();
	}

/*

	public Enumeration getUserKeys(String name)

	: Retrieve all the keys associated with the given user. If the user
	  with the specified name does not exist, it does nothing

*/

	public Enumeration getUserKeys(String name) {

		ResultSet rs;
		PreparedStatement pstmt;
		Vector v = new Vector(20);
		String command = "SELECT key FROM user_data WHERE name = '" + name + "'"; 

		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				rs = pstmt.executeQuery();

				while (rs.next()) {

					v.addElement(rs.getString(1));
				} 

				pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch (SQLException e) {

			e.printStackTrace();
		}

		return v.elements();
	}


/*

	public void addUser(String name) 

	: Create the new user. If the user with the given name already exsits,
	  it is removed (including all his/her keys) and added (only with the
	  name)

*/

	public void addUser(String name) {

		PreparedStatement pstmt;
		String command = "INSERT INTO users (name) values ('" + name + "')";

		if (containsUser(name)) {
	
			// if the user with the given name already exists

			removeUser(name);
		}
		
		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				pstmt.executeUpdate();
				pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch (SQLException e) {

			e.printStackTrace();
		}
	}


/*

	public void removeUser(String name)

	: Removes the given user with all keys. If the user with the specified
	  name does not exist, it does nothing.

*/

	public void removeUser(String name) {

		PreparedStatement pstmt;
		String command = "DELETE FROM user_data WHERE name = '" + name + "'"; 
		String command2 = "DELETE FROM users WHERE name = '" + name + "'";
		
		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				pstmt.executeUpdate();
				pstmt.close();

				pstmt = conn.prepareStatement(command2);
				pstmt.executeUpdate();
				pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch (SQLException e) {

			e.printStackTrace();
		}
	}


/*

	public void removeKey(String name, String key)

	: Remove the key of the given user. If the user with the given name
	  or the specified key does not exsit, it does nothing. 

*/

	public void removeKey(String name, String key) {

		PreparedStatement pstmt;
		String command = "DELETE FROM user_data WHERE name = '" + name 
						+ "' AND key = '" + key.toLowerCase() + "'";

		try {

			 if (conn != null) {

				pstmt = conn.prepareStatement(command);
				pstmt.executeUpdate();
				pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch(SQLException e) {

			e.printStackTrace();
		}
	}


/*

	public void setValue(String name, String key, String value)

	: Modify the value of the specified key for the given user. If the key
	  does not exist, it is created. If the user with the specified name
	  does not exist, it does nothing.

*/

	public void setValue(String name, String key, String value) {

		PreparedStatement pstmt;
		String command = "UPDATE user_data SET value = '" + value 
						+ "' WHERE name = '" + name + "' AND key = '"
						+ key.toLowerCase() + "'";
		int row;

		if (!containsUser(name)) {

			// if the user with the specified name does not exist

			return;
		}

		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				row = pstmt.executeUpdate();
				pstmt.close();

				if (row < 1) {

					throw new SQLException();
				}

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch (SQLException e) {

			// if the key does not exist, it is created

			addKey(name, key, value);
		}
	}


/*

	private void addKey(String name, String key, String value)

	: Create the new key and its value for the given user.

*/

	private void addKey(String name, String key, String value) {

		PreparedStatement pstmt;
		String command = "INSERT INTO user_data (name, key, value) "
						+ "VALUES ('" + name + "','" + key.toLowerCase() 
						+ "','" + value + "')";

		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				pstmt.executeUpdate();
				pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}
	
		} catch (SQLException e) {

			e.printStackTrace();
		}
	}


/*

	private boolean containsUser(String name) 

	: Check if the user with the given name exists or not.

*/

	private boolean containsUser(String name) {

		PreparedStatement pstmt;
		String command = "SELECT name FROM users WHERE name = '" + name + "'";
		String value = null;
		ResultSet rs;

		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				rs = pstmt.executeQuery();

				if (rs.next()) {

					value = rs.getString(1);
				}

				pstmt.close();

			} else {

				throw new java.sql.SQLException("Not connected to database");
			}

		} catch (SQLException e) {
	
			e.printStackTrace();
		}

		if (value != null && value.equals(name)) {
	
			return true;
		
		} else {
		
			return false;
		}
	}

}

